#!/usr/bin/haserl -u 100
<% . /usr/local/lib/cgi/generic.sh ; print_http_hdr %>
<% . /usr/local/lib/cgi/config.sh %>


<html>
<head>
<head><link href="/sys/css/basic.css" rel="stylesheet" 
type="text/css"></head>
</head> 
<body>
<b>UPLOAD CONFIGURATION FILE</b><p>

<%
	# first check if return page is not set
	if [ "$FORM_return_page"X = "X" ] ; then FORM_return_page="index.cgi"; fi
	chanNo=0
	entryNo=0
	CSV_FILE=/tmp/csv.txt
	
	# handle the case of "Mac" terminated file-i.e CR instead of LC or CRLF
	# infact convert Windows OR Mac to Linux (LF only terminated files)
	cat "$FORM_csv_file" | tr '\r\n' '\n' | tr '\r' '\n'> "$CSV_FILE"
	
	oldIFS="$IFS"

    while read text_line || [[ -n "$text_line" ]] ; do
    	let entryNo++
    	isInvalid=""
    	echo "<br>Importing config entry $entryNo:<br> $text_line <br>"
    	echo "Reading entry: $entryNo" >> /tmp/debug.txt
    	# validate separators
    	IFS=','; read -r -a arr <<< "$text_line"
    	IFS="$oldIFS"
    	num_sep=$(tr -dc ',' <<<"$text_line" | wc -c)
    	echo "num_sep=$num_sep" >> /tmp/debug.txt
    	if [ "$num_sep" -ne 9 ]; then
    		echo "Invalid number $num_sep of parameters in this entry. Fix the config file and try again !<br>"
    		isInvalid="yes"
    	fi

    	# use if ... then construct because continue does not work with read
    	if [ "$isInvalid" == "" ]; then
    		# check other conditions
    		# no IP, or invalid mcast address
    		if [ "${arr[0]}" == "" ]; then
    			echo "No IP defined! Ignoring this entry !<br>"
    			isInvalid="yes"
    		fi
    		
			mcast_not_ok=$(echo "${arr[0]}" | awk -F . '{if ($1 <224 || $1 >239 || $2 <0 || $2 >255 || $3 <0 || $3 >255 || $4 <0 || $4 >255 || NF !=4) print "Not OK"}')
			if [ "$mcast_not_ok" != "" ]; then
				echo "${arr[0]} is not a valid multicast address!  Ignoring this entry !<br>"
				isInvalid="yes"
			fi
    		
    		# port empty, not a number, or out of range
    		if [ "${arr[1]}" == "" ]; then
    			echo "No port defined! Ignoring this entry !<br>"
    			isInvalid="yes"
    		fi
    		port_not_ok=$(echo "${arr[1]}" | awk '{if ($1 ~ /^[0-9]+$/ && $0 > 0 && $0 <= 65535) print ""; else print "Not OK"}')
			if [ "$port_not_ok" != "" ] ; then
  				echo "The port is not an integer number, or is out of the [1-65535] range! Ignoring this entry !<br>"
    			isInvalid="yes"
			fi
			
			# check for single quote, double quote, semicolon, and comma in the Channel Name
			num_chr1=$(tr -dc '";,' <<<"${arr[8]}" | wc -c)
			num_chr2=$(tr -dc "'" <<<"${arr[8]}" | wc -c)
			if  [ "$num_chr1" != 0 ] || [ "$num_chr2" != 0 ] ; then
				echo "Use of single quote, double quote, or semicolon in  Channel Name detected! Ignoring this entry !<br>"
				isInvalid="yes"
			fi
    		
#    		echo "isInvalid=$isInvalid<br>" 
			if [ "$isInvalid" == "" ] ; then		
				# store the entry in uci
				let chanNo++
				echo "Storing channel $chanNo:<br>$text_line<br>"
				rv=$(/sbin/uci -q set "application.channels.chan_$chanNo=$text_line")
				rv=$(/sbin/uci commit)
			fi
		fi
	done < "$CSV_FILE"
		
	# set the number of channels only if we had any valid entries imported
	if [ "$chanNo" -gt 0 ]; then
		rv=$(/sbin/uci -q set application.general.channel_count="$chanNo")
		echo "<br>Totally imported channels: $chanNo<br>"
	fi
	echo '
	<p>Uploading configuration finished. Reload the <a href=/cgi-bin/uibasic.cgi>Channel Settings</a> page to verify it, and restart the application from the home page.'
	fi
%>
</body>
</html>
