// Audio Point Channel List Server home page scripts
// table header on the home page
// fields to display
var tableHeader = ["Channel Name","Server IP","Subscription Port","Client Number","Local Input"];
// parameters as they arrive from UCI
var statusHeader = ["Server IP","Subscription Port","Priority","Interrupt call","Show Ads","Show Ads Stopped","Frame Buffer Size","Channel Name","Channel Logo URL","Local Input","Local Port"];
// client number data format
var totalChannels=0;
var theSplitVars;
var channelsStatus = [];

function sendRequest() {
	if (window.XMLHttpRequest)
	{// code for IE7+, Firefox, Chrome, Opera, Safari
		req=new XMLHttpRequest();
		// fix for MSIE
		if (req.overrideMimeType) req.overrideMimeType("text/html; charset=ISO-8859-1");
	}
	else
	{// code for IE6, IE5
		req=new ActiveXObject("Microsoft.XMLHTTP");
	}
	var randomReloadNo=Math.floor(Math.random()*1001);
 	var URL = '/cgi-bin/get_data.cgi?'+randomReloadNo;
 	if (responseReceived == 1){
 		responseReceived = 0;
 	}else{
 		set_txt('server_status',String.fromCharCode(160)+'Server not reachable !!!');
		get_elem('server_status').style.color = "Red";
 	}
	req.open("GET",URL,true);
	// workaround for MSIE caching problem
	req.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
	req.onreadystatechange=function() { if (this.readyState==4 && this.status==200) updateLoadedValues(this.responseText); }
	try { req.send(null);} catch(err) {}

  	return false;
}

function updateChannelsStatus(channels){
	channelsStatus = channels;
}

function updateLoadedValues(responseText){
    responseReceived=1;

    theSplitVars = responseText.split(";");

    set_txt('server_ip', String.fromCharCode(160)+theSplitVars[0]);

    processPid = parseInt(theSplitVars[1], 10);
    // do not update page if it contains garbage
    if (theSplitVars[0] != "" && isNaN(processPid)) return 0;

    totalChannels=parseInt(theSplitVars[2],10);

    if (theSplitVars[3] == "master") {
        set_txt('ch_list_status', String.fromCharCode(160)+'ON');
        get_elem('ch_list_status').style.color = "Green";
    }
    else if (theSplitVars[3] == "slave") {
        set_txt('ch_list_status', String.fromCharCode(160)+'OFF');
        get_elem('ch_list_status').style.color = "Red";
    }

    if (theSplitVars[4].startsWith("Valid")) {
        set_txt('license_status', String.fromCharCode(160)+theSplitVars[4]);
        get_elem('license_status').style.color = "Green";
    } 
    else {
        set_txt('license_status', String.fromCharCode(160)+theSplitVars[4]);
        get_elem('license_status').style.color = "Red";
    }

    var tempRow;
    //clear the table
    clearTable('status_table');
    setStatusTableHeader();
    drawnStatusChannels=0;
    // create the table with all entries
    for (row_number=1; row_number <= totalChannels; row_number++){
	    tempRow=appendNewRow('status_table');
        // fill-in the content
        updateStatusRow(row_number);
    }
    // update also the application status
    if ( processPid > 0){
        set_txt('server_status', String.fromCharCode(160)+'Server is running...');
    	get_elem('server_status').style.color = "Green";
        get_elem('toggle_btn').value="Stop server";
        get_elem('toggle_btn').title="Click here to stop the Audio Point";
    }else{
        set_txt('server_status', String.fromCharCode(160)+'Server stopped!');
    	get_elem('server_status').style.color = "Red";
        get_elem('toggle_btn').value="Start server";
        get_elem('toggle_btn').title="Click here to start the Audio Point";
    }
    	
}

function clearTable(table_name){
    var tableToClear=get_elem(table_name);
    // leave the table header
    for (rowNo=tableToClear.rows.length-1;rowNo>0;rowNo--){
        tableToClear.deleteRow(rowNo);
    }
}


function updateStatusRow(channelNo){
    //entry line from the parsed array
    var rowEntry = parseInt(channelNo,10) + 4;
    var statusTable=get_elem("status_table");
    var tableRow=statusTable.rows[channelNo];
    var rowDataEntry=theSplitVars[rowEntry];
    var rowData=rowDataEntry.split(",");
    var name = rowData[statusHeader.indexOf("Channel Name")];
    var port = rowData[statusHeader.indexOf("Subscription Port")];
    var local_input = rowData[statusHeader.indexOf("Local Input")];
    var ip;
    if (local_input == "none") {
        ip = rowData[statusHeader.indexOf("Server IP")];
    } else {
        ip = location.host;
    }
    tableRow.cells[tableHeader.indexOf("Channel Name")].innerHTML = name;
    tableRow.cells[tableHeader.indexOf("Server IP")].innerHTML = ip;
    tableRow.cells[tableHeader.indexOf("Subscription Port")].innerHTML = port;
    tableRow.cells[tableHeader.indexOf("Client Number")].innerHTML = getChannelUsers(ip, port);
    tableRow.cells[tableHeader.indexOf("Local Input")].innerHTML = local_input;
}

function setStatusTableHeader(){
    var statusTable=get_elem("status_table");
    var headerRow=statusTable.rows[0];
    for (headerCell=0;headerCell < tableHeader.length; headerCell++){
        headerRow.cells[headerCell].innerHTML=tableHeader[headerCell];
    }
}

function appendNewRow(tableName){
    var targetTable=get_elem(tableName);
    var newRow=targetTable.insertRow(targetTable.rows.length);
    var tempCellElem;
    // generate the cells
    var c=0;
    while (cellNo=targetTable.rows[0].cells[c++]){
        tempCellElem=newRow.insertCell(cellNo); set_txt(tempCellElem,"");
    }

    return newRow;
}

function getChannelUsers(ip, port) {
    for (i = 0; i < channelsStatus.length; i++) {
        if (channelsStatus[i].address == ip && channelsStatus[i].port == port) {
            return channelsStatus[i].users;
        }
    }
    return "-";
}
